unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  System.Bluetooth, FMX.StdCtrls, FMX.Controls.Presentation,
  System.Bluetooth.Components;

type
  TForm1 = class(TForm)
    Bluetooth1: TBluetooth;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label1: TLabel;
    procedure Button1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Button1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Button2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Button2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Button3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Button3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Button4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Button4MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Bluetooth1DiscoveryEnd(const Sender: TObject;
      const ADeviceList: TBluetoothDeviceList);
  private
    { Private declarations }
    FSocket : TBluetoothSocket;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.Bluetooth1DiscoveryEnd(const Sender: TObject;
  const ADeviceList: TBluetoothDeviceList);
var
  ADevice   : TBluetoothDevice;
  AService  : TBluetoothService;

begin
  for ADevice in ADeviceList do
    begin
    if( ADevice.DeviceName = 'HC-06' ) then
      begin
      Bluetooth1.Pair( ADevice );
      for AService in ADevice.LastServiceList do
        begin
        FSocket := ADevice.CreateClientSocket( AService.UUID, False );
        if( FSocket <> NIL ) then
          begin
          FSocket.Connect();
          Label1.Visible := False;
          Button1.Enabled := True;
          Button2.Enabled := True;
          Button3.Enabled := True;
          Button4.Enabled := True;
          Break;
          end;
        end;

      Break;
      end;

    end;

end;

procedure TForm1.Button1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  FSocket.SendData( TEncoding.UTF8.GetBytes( 'f' ));
end;

procedure TForm1.Button1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  FSocket.SendData( TEncoding.UTF8.GetBytes( 'F' ));
end;

procedure TForm1.Button2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  FSocket.SendData( TEncoding.UTF8.GetBytes( 'l' ));
end;

procedure TForm1.Button2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  FSocket.SendData( TEncoding.UTF8.GetBytes( 'L' ));
end;

procedure TForm1.Button3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  FSocket.SendData( TEncoding.UTF8.GetBytes( 'r' ));
end;

procedure TForm1.Button3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  FSocket.SendData( TEncoding.UTF8.GetBytes( 'R' ));
end;

procedure TForm1.Button4MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  FSocket.SendData( TEncoding.UTF8.GetBytes( 'b' ));
end;

procedure TForm1.Button4MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  FSocket.SendData( TEncoding.UTF8.GetBytes( 'B' ));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Bluetooth1.DiscoverDevices( 5000 );
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil( FSocket );
end;

end.
